# Edit this configuration file to define what should be installed on
# your system. Help is available in the configuration.nix(5) man page, on
# https://search.nixos.org/options and in the NixOS manual (`nixos-help`).

# NixOS-WSL specific options are documented on the NixOS-WSL repository:
# https://github.com/nix-community/NixOS-WSL

{
  config,
  lib,
  pkgs,
  ...
}:
let
  cfg = config.services.forgejo;
  srv = cfg.settings.server;
in
{
  imports = [
    ./shared/system.nix
    ./shared/dev_user.nix
    ./shared/docker.nix
    ./shared/ssh.nix
  ];

  services = {
    gitea-actions-runner = {
      package = pkgs.forgejo-actions-runner;
      instances.default = {
        enable = true;
        name = "linux-runner";
        url = "https://pts-paper.de";
        token = "R8ln9xooQn6RhUZ7vfDtCmj3835JxonZIR2DLAQX";
        labels = [
          "ubuntu-latest:docker://node:16-bullseye"
          "ubuntu-22.04:docker://node:16-bullseye"
          "ubuntu-20.04:docker://node:16-bullseye"
        ];
        settings = {
          runner = {
            capacity = 4;
            envs = {
              DOCKER_HOST = "unix:///var/run/docker.sock";
            };
          };
          container = {
            privileged = true;
            valid_volumes = [
              "/var/run/docker.sock"
            ];
          };
        };
      };
    };
  };

  virtualisation = {
    oci-containers = {
      containers = {
        forgejo_runner = {
          image = vegardit/gitea-act-runner:dind-latest;
          autoStart = true;
          privileged = true;
          environment = {
            GITEA_INSTANCE_URL = "https://pts-paper.de";
            GITEA_RUNNER_REGISTRATION_TOKEN = "YFmYnj31ikOh0Ja53hI9ehA1je0jlzP1KCBk2wMi";
          };
        }
      }
    };
  };
}
